Initial commit

This commit is contained in:
Gergely Polonkai 2025-03-18 19:21:17 +01:00
commit 8303887c16
No known key found for this signature in database
GPG Key ID: 2D2885533B869ED4
137 changed files with 4067 additions and 0 deletions

2
.gitignore vendored Normal file
View File

@ -0,0 +1,2 @@
/fishd.*
/fish_variables

1
completions/breeze.fish Normal file
View File

@ -0,0 +1 @@
complete -c breeze -d "Shortcut tools for git command."

7
completions/fisher.fish Normal file
View File

@ -0,0 +1,7 @@
complete --command fisher --exclusive --long help --description "Print help"
complete --command fisher --exclusive --long version --description "Print version"
complete --command fisher --exclusive --condition __fish_use_subcommand --arguments install --description "Install plugins"
complete --command fisher --exclusive --condition __fish_use_subcommand --arguments update --description "Update installed plugins"
complete --command fisher --exclusive --condition __fish_use_subcommand --arguments remove --description "Remove installed plugins"
complete --command fisher --exclusive --condition __fish_use_subcommand --arguments list --description "List installed plugins matching regex"
complete --command fisher --exclusive --condition "__fish_seen_subcommand_from update remove" --arguments "(fisher list)"

15
completions/gpg-tui.fish Normal file
View File

@ -0,0 +1,15 @@
complete -c gpg-tui -l config -d 'Sets the configuration file' -r
complete -c gpg-tui -l homedir -d 'Sets the GnuPG home directory' -r
complete -c gpg-tui -s o -l outdir -d 'Sets the output directory' -r
complete -c gpg-tui -l outfile -d 'Sets the template for the output file name' -r
complete -c gpg-tui -s d -l default-key -d 'Sets the default key to sign with' -r
complete -c gpg-tui -s t -l tick-rate -d 'Sets the tick rate of the terminal' -r
complete -c gpg-tui -s c -l color -d 'Sets the accent color of the terminal' -r
complete -c gpg-tui -s s -l style -d 'Sets the style of the terminal' -r -f -a "{plain 'Plain style with basic colors',colored 'More rich style with highlighted widgets and more colors'}"
complete -c gpg-tui -s f -l file-explorer -d 'Sets the utility for file selection' -r
complete -c gpg-tui -l detail-level -d 'Sets the detail level for the keys' -r -f -a "{minimum 'Show only the primary key and user ID',standard 'Show all subkeys and user IDs',full 'Show signatures'}"
complete -c gpg-tui -l select -d 'Enables the selection mode' -r -f -a "{row1 'One of the selected rows of the keys table',row2 'The other selected row of the keys table',key 'Exported key',key-id 'ID of the selected key',key-fingerprint 'Fingerprint of the selected key',user-id 'User ID of the selected key'}"
complete -c gpg-tui -s a -l armor -d 'Enables ASCII armored output'
complete -c gpg-tui -l splash -d 'Shows the splash screen on startup'
complete -c gpg-tui -s h -l help -d 'Print help (see more with \'--help\')'
complete -c gpg-tui -s V -l version -d 'Print version'

19
completions/mailctl.fish Normal file
View File

@ -0,0 +1,19 @@
function _mailctl
set -l cl (commandline --tokenize --current-process)
# Hack around fish issue #3934
set -l cn (commandline --tokenize --cut-at-cursor --current-process)
set -l cn (count $cn)
set -l tmpline --bash-completion-enriched --bash-completion-index $cn
for arg in $cl
set tmpline $tmpline --bash-completion-word $arg
end
for opt in (/usr/bin/mailctl $tmpline)
if test -d $opt
echo -E "$opt/"
else
echo -E "$opt"
end
end
end
complete --no-files --command mailctl --arguments '(_mailctl)'

145
completions/poetry.fish Normal file
View File

@ -0,0 +1,145 @@
function __fish_poetry_35397e76055aceaf_complete_no_subcommand
for i in (commandline -opc)
if contains -- $i about add build cache:clear check config debug:info debug:resolve develop help init install list lock new publish remove run script search self:update shell show update version
return 1
end
end
return 0
end
# global options
complete -c poetry -n '__fish_poetry_35397e76055aceaf_complete_no_subcommand' -l ansi -d 'Force ANSI output'
complete -c poetry -n '__fish_poetry_35397e76055aceaf_complete_no_subcommand' -l help -d 'Display this help message'
complete -c poetry -n '__fish_poetry_35397e76055aceaf_complete_no_subcommand' -l no-ansi -d 'Disable ANSI output'
complete -c poetry -n '__fish_poetry_35397e76055aceaf_complete_no_subcommand' -l no-interaction -d 'Do not ask any interactive question'
complete -c poetry -n '__fish_poetry_35397e76055aceaf_complete_no_subcommand' -l quiet -d 'Do not output any message'
complete -c poetry -n '__fish_poetry_35397e76055aceaf_complete_no_subcommand' -l verbose -d 'Increase the verbosity of messages: 1 for normal output, 2 for more verbose output and 3 for debug'
complete -c poetry -n '__fish_poetry_35397e76055aceaf_complete_no_subcommand' -l version -d 'Display this application version'
# commands
complete -c poetry -f -n '__fish_poetry_35397e76055aceaf_complete_no_subcommand' -a about -d 'Short information about Poetry.'
complete -c poetry -f -n '__fish_poetry_35397e76055aceaf_complete_no_subcommand' -a add -d 'Add a new dependency to pyproject.toml.'
complete -c poetry -f -n '__fish_poetry_35397e76055aceaf_complete_no_subcommand' -a build -d 'Builds a package, as a tarball and a wheel by default.'
complete -c poetry -f -n '__fish_poetry_35397e76055aceaf_complete_no_subcommand' -a cache:clear -d 'Clears poetry\'s cache.'
complete -c poetry -f -n '__fish_poetry_35397e76055aceaf_complete_no_subcommand' -a check -d 'Checks the validity of the pyproject.toml file.'
complete -c poetry -f -n '__fish_poetry_35397e76055aceaf_complete_no_subcommand' -a config -d 'Sets/Gets config options.'
complete -c poetry -f -n '__fish_poetry_35397e76055aceaf_complete_no_subcommand' -a debug:info -d 'Shows debug information.'
complete -c poetry -f -n '__fish_poetry_35397e76055aceaf_complete_no_subcommand' -a debug:resolve -d 'Debugs dependency resolution.'
complete -c poetry -f -n '__fish_poetry_35397e76055aceaf_complete_no_subcommand' -a develop -d 'Installs the current project in development mode. (Deprecated)'
complete -c poetry -f -n '__fish_poetry_35397e76055aceaf_complete_no_subcommand' -a help -d 'Displays help for a command'
complete -c poetry -f -n '__fish_poetry_35397e76055aceaf_complete_no_subcommand' -a init -d 'Creates a basic pyproject.toml file in the current directory.'
complete -c poetry -f -n '__fish_poetry_35397e76055aceaf_complete_no_subcommand' -a install -d 'Installs the project dependencies.'
complete -c poetry -f -n '__fish_poetry_35397e76055aceaf_complete_no_subcommand' -a list -d 'Lists commands'
complete -c poetry -f -n '__fish_poetry_35397e76055aceaf_complete_no_subcommand' -a lock -d 'Locks the project dependencies.'
complete -c poetry -f -n '__fish_poetry_35397e76055aceaf_complete_no_subcommand' -a new -d 'Creates a new Python project at <path>'
complete -c poetry -f -n '__fish_poetry_35397e76055aceaf_complete_no_subcommand' -a publish -d 'Publishes a package to a remote repository.'
complete -c poetry -f -n '__fish_poetry_35397e76055aceaf_complete_no_subcommand' -a remove -d 'Removes a package from the project dependencies.'
complete -c poetry -f -n '__fish_poetry_35397e76055aceaf_complete_no_subcommand' -a run -d 'Runs a command in the appropriate environment.'
complete -c poetry -f -n '__fish_poetry_35397e76055aceaf_complete_no_subcommand' -a script -d 'Executes a script defined in pyproject.toml. (Deprecated)'
complete -c poetry -f -n '__fish_poetry_35397e76055aceaf_complete_no_subcommand' -a search -d 'Searches for packages on remote repositories.'
complete -c poetry -f -n '__fish_poetry_35397e76055aceaf_complete_no_subcommand' -a self:update -d 'Updates poetry to the latest version.'
complete -c poetry -f -n '__fish_poetry_35397e76055aceaf_complete_no_subcommand' -a shell -d 'Spawns a shell within the virtual environment.'
complete -c poetry -f -n '__fish_poetry_35397e76055aceaf_complete_no_subcommand' -a show -d 'Shows information about packages.'
complete -c poetry -f -n '__fish_poetry_35397e76055aceaf_complete_no_subcommand' -a update -d 'Update dependencies as according to the pyproject.toml file.'
complete -c poetry -f -n '__fish_poetry_35397e76055aceaf_complete_no_subcommand' -a version -d 'Bumps the version of the project.'
# command options
# about
# add
complete -c poetry -A -n '__fish_seen_subcommand_from add' -l allow-prereleases -d 'Accept prereleases.'
complete -c poetry -A -n '__fish_seen_subcommand_from add' -l dev -d 'Add package as development dependency.'
complete -c poetry -A -n '__fish_seen_subcommand_from add' -l dry-run -d 'Outputs the operations but will not execute anything (implicitly enables --verbose).'
complete -c poetry -A -n '__fish_seen_subcommand_from add' -l extras -d 'Extras to activate for the dependency.'
complete -c poetry -A -n '__fish_seen_subcommand_from add' -l git -d 'The url of the Git repository.'
complete -c poetry -A -n '__fish_seen_subcommand_from add' -l optional -d 'Add as an optional dependency.'
complete -c poetry -A -n '__fish_seen_subcommand_from add' -l path -d 'The path to a dependency.'
complete -c poetry -A -n '__fish_seen_subcommand_from add' -l platform -d 'Platforms for which the dependencies must be installed.'
complete -c poetry -A -n '__fish_seen_subcommand_from add' -l python -d 'Python version( for which the dependencies must be installed.'
# build
complete -c poetry -A -n '__fish_seen_subcommand_from build' -l format -d 'Limit the format to either wheel or sdist.'
# cache:clear
complete -c poetry -A -n '__fish_seen_subcommand_from cache:clear' -l all -d 'Clear all entries in cache.'
# check
# config
complete -c poetry -A -n '__fish_seen_subcommand_from config' -l list -d 'List configuration settings'
complete -c poetry -A -n '__fish_seen_subcommand_from config' -l unset -d 'Unset configuration setting'
# debug:info
# debug:resolve
complete -c poetry -A -n '__fish_seen_subcommand_from debug:resolve' -l extras -d 'Extras to activate for the dependency.'
complete -c poetry -A -n '__fish_seen_subcommand_from debug:resolve' -l install -d 'Show what would be installed for the current system.'
complete -c poetry -A -n '__fish_seen_subcommand_from debug:resolve' -l python -d 'Python version(s) to use for resolution.'
complete -c poetry -A -n '__fish_seen_subcommand_from debug:resolve' -l tree -d 'Displays the dependency tree.'
# develop
# help
complete -c poetry -A -n '__fish_seen_subcommand_from help' -l format -d 'The output format (txt, json, or md)'
complete -c poetry -A -n '__fish_seen_subcommand_from help' -l raw -d 'To output raw command help'
# init
complete -c poetry -A -n '__fish_seen_subcommand_from init' -l author -d 'Author name of the package'
complete -c poetry -A -n '__fish_seen_subcommand_from init' -l dependency -d 'Package to require with an optional version constraint, e.g. requests:^2.10.0 or requests=2.11.1'
complete -c poetry -A -n '__fish_seen_subcommand_from init' -l description -d 'Description of the package'
complete -c poetry -A -n '__fish_seen_subcommand_from init' -l dev-dependency -d 'Package to require for development with an optional version constraint, e.g. requests:^2.10.0 or requests=2.11.1'
complete -c poetry -A -n '__fish_seen_subcommand_from init' -l license -d 'License of the package'
complete -c poetry -A -n '__fish_seen_subcommand_from init' -l name -d 'Name of the package'
# install
complete -c poetry -A -n '__fish_seen_subcommand_from install' -l develop -d 'Install given packages in development mode.'
complete -c poetry -A -n '__fish_seen_subcommand_from install' -l dry-run -d 'Outputs the operations but will not execute anything (implicitly enables --verbose).'
complete -c poetry -A -n '__fish_seen_subcommand_from install' -l extras -d 'Extra sets of dependencies to install.'
complete -c poetry -A -n '__fish_seen_subcommand_from install' -l no-dev -d 'Do not install dev dependencies.'
# list
complete -c poetry -A -n '__fish_seen_subcommand_from list' -l format -d 'The output format (txt, json, or md)'
complete -c poetry -A -n '__fish_seen_subcommand_from list' -l raw -d 'To output raw command list'
# lock
# new
complete -c poetry -A -n '__fish_seen_subcommand_from new' -l name -d 'Set the resulting package name.'
complete -c poetry -A -n '__fish_seen_subcommand_from new' -l src -d 'Use the src layout for the project.'
# publish
complete -c poetry -A -n '__fish_seen_subcommand_from publish' -l build -d 'Build the package before publishing.'
complete -c poetry -A -n '__fish_seen_subcommand_from publish' -l password -d 'The password to access the repository.'
complete -c poetry -A -n '__fish_seen_subcommand_from publish' -l repository -d 'The repository to publish the package to.'
complete -c poetry -A -n '__fish_seen_subcommand_from publish' -l username -d 'The username to access the repository.'
# remove
complete -c poetry -A -n '__fish_seen_subcommand_from remove' -l dev -d 'Removes a package from the development dependencies.'
complete -c poetry -A -n '__fish_seen_subcommand_from remove' -l dry-run -d 'Outputs the operations but will not execute anything (implicitly enables --verbose).'
# run
# script
# search
complete -c poetry -A -n '__fish_seen_subcommand_from search' -l only-name -d 'Search only in name.'
# self:update
complete -c poetry -A -n '__fish_seen_subcommand_from self:update' -l preview -d 'Install prereleases.'
# shell
# show
complete -c poetry -A -n '__fish_seen_subcommand_from show' -l all -d 'Show all packages (even those not compatible with current system).'
complete -c poetry -A -n '__fish_seen_subcommand_from show' -l latest -d 'Show the latest version.'
complete -c poetry -A -n '__fish_seen_subcommand_from show' -l no-dev -d 'Do not list the dev dependencies.'
complete -c poetry -A -n '__fish_seen_subcommand_from show' -l outdated -d 'Show the latest version but only for packages that are outdated.'
complete -c poetry -A -n '__fish_seen_subcommand_from show' -l tree -d 'List the dependencies as a tree.'
# update
complete -c poetry -A -n '__fish_seen_subcommand_from update' -l dry-run -d 'Outputs the operations but will not execute anything (implicitly enables --verbose).'
complete -c poetry -A -n '__fish_seen_subcommand_from update' -l lock -d 'Do not perform install (only update the lockfile).'
complete -c poetry -A -n '__fish_seen_subcommand_from update' -l no-dev -d 'Do not install dev dependencies.'
# version

12
completions/tide.fish Normal file
View File

@ -0,0 +1,12 @@
complete tide --no-files
set -l subcommands bug-report configure
complete tide -x -n __fish_use_subcommand -a bug-report -d "Print info for use in bug reports"
complete tide -x -n __fish_use_subcommand -a configure -d "Run the configuration wizard"
complete tide -x -n "not __fish_seen_subcommand_from $subcommands" -s h -l help -d "Print help message"
complete tide -x -n "not __fish_seen_subcommand_from $subcommands" -s v -l version -d "Print tide version"
complete tide -x -n '__fish_seen_subcommand_from bug-report' -l clean -d "Run clean Fish instance and install Tide"
complete tide -x -n '__fish_seen_subcommand_from bug-report' -l verbose -d "Print full Tide configuration"

41
conf.d/_tide_init.fish Normal file
View File

@ -0,0 +1,41 @@
function _tide_init_install --on-event _tide_init_install
set -U VIRTUAL_ENV_DISABLE_PROMPT true
source (functions --details _tide_sub_configure)
_load_config lean
_tide_finish
if status is-interactive
tide bug-report --check || sleep 4
if contains ilancosman/tide (string lower $_fisher_plugins)
set_color bryellow
echo "ilancosman/tide is a development branch. Please install from a release tag:"
echo -ns "fisher install ilancosman/tide@v5" | fish_indent --ansi
sleep 3
end
switch (read --prompt-str="Configure tide prompt? [Y/n] " | string lower)
case y ye yes ''
tide configure
case '*'
echo -s \n 'Run ' (echo -ns "tide configure" | fish_indent --ansi) ' to customize your prompt.'
end
end
end
function _tide_init_update --on-event _tide_init_update
# Warn users who install from main branch
if contains ilancosman/tide (string lower $_fisher_plugins)
set_color bryellow
echo "ilancosman/tide is a development branch. Please install from a release tag:"
echo -ns "fisher install ilancosman/tide@v5" | fish_indent --ansi
sleep 3
end
end
function _tide_init_uninstall --on-event _tide_init_uninstall
set -e VIRTUAL_ENV_DISABLE_PROMPT
set -e (set -U --names | string match --entire -r '^_?tide')
functions --erase (functions --all | string match --entire -r '^_?tide')
end

1
conf.d/aliases.fish Normal file
View File

@ -0,0 +1 @@
alias vim nvim

1
conf.d/android.fish Normal file
View File

@ -0,0 +1 @@
fish_add_path $HOME/Android/Sdk/platform-tools

1
conf.d/atuin.fish Normal file
View File

@ -0,0 +1 @@
status --is-interactive; and atuin init fish | source

2
conf.d/bat.fish Normal file
View File

@ -0,0 +1,2 @@
alias cat bat
set -gx BAT_THEME OneHalfDark

2
conf.d/binenv.fish Normal file
View File

@ -0,0 +1,2 @@
fish_add_path $HOME/.binenv
binenv completion fish | source

85
conf.d/breeze.fish Normal file
View File

@ -0,0 +1,85 @@
abbr -a cdgtop 'cd (git rev-parse --show-toplevel)'
abbr -a g 'git'
abbr -a gaa 'git add --all'
abbr -a gap 'git add -pu'
abbr -a gash 'git stash'
abbr -a gasha 'git stash apply'
abbr -a gashl 'git stash list'
abbr -a gashp 'git stash pop'
abbr -a gashu 'git stash --include-untracked'
abbr -a gau 'git add -u'
abbr -a gc 'git commit'
abbr -a gce 'git clean'
abbr -a gcef 'git clean -fd'
abbr -a gcl 'git clone'
abbr -a gcmsg 'git commit -m'
abbr -a gdf 'git diff --'
abbr -a gdnw 'git diff -w --'
abbr -a gdw 'git diff --word-diff'
abbr -a gf 'git fetch'
abbr -a gfa 'git fetch --all'
abbr -a gfr 'git fetch; and git rebase'
abbr -a glg 'git log --graph --max-count=5'
abbr -a gm 'git merge'
abbr -a gmff 'git merge --ff'
abbr -a gmnff 'git merge --no-ff'
abbr -a gopen 'git config --get remote.origin.url | xargs open'
abbr -a gpl 'git pull'
abbr -a gplr 'git pull --rebase'
abbr -a gps 'git push'
abbr -a gpsf 'git push --force-with-lease'
abbr -a gr 'git remote -v'
abbr -a grb 'git rebase'
abbr -a grbi 'git rebase -i'
abbr -a grs 'git reset --'
abbr -a grsh 'git reset --hard'
abbr -a grsl 'git reset HEAD~'
abbr -a gsh 'git show'
abbr -a gt 'git tag'
abbr -a gtop 'git rev-parse --show-toplevel'
abbr -a gurl 'git config --get remote.origin.url'
abbr -a runsv 'python -m SimpleHTTPServer'
function _breeze_uninstall -e breeze_uninstall
abbr -e cdgtop
abbr -e g
abbr -e gaa
abbr -e gap
abbr -e gash
abbr -e gasha
abbr -e gashl
abbr -e gashp
abbr -e gashu
abbr -e gau
abbr -e gc
abbr -e gce
abbr -e gcef
abbr -e gcl
abbr -e gcmsg
abbr -e gdf
abbr -e gdnw
abbr -e gdw
abbr -e gf
abbr -e gfa
abbr -e gfr
abbr -e glg
abbr -e gm
abbr -e gmff
abbr -e gmnff
abbr -e gopen
abbr -e gpl
abbr -e gplr
abbr -e gps
abbr -e gpsf
abbr -e gr
abbr -e grb
abbr -e grbi
abbr -e grs
abbr -e grsh
abbr -e grsl
abbr -e gsh
abbr -e gt
abbr -e gtop
abbr -e gurl
abbr -e runsv
end

2
conf.d/deno.fish Normal file
View File

@ -0,0 +1,2 @@
set -gx DENO_INSTALL "$HOME/.deno"
fish_add_path $DENO_INSTALL/bin

5
conf.d/dircolors.fish Normal file
View File

@ -0,0 +1,5 @@
set NORD_DIR_COLORS_FILE $HOME/.local/nord-dircolors/dir_colors
if test -f $NORD_DIR_COLORS_FILE
eval (dircolors -c $NORD_DIR_COLORS_FILE)
end

2
conf.d/direnv.fish Normal file
View File

@ -0,0 +1,2 @@
direnv hook fish | source
set -g direnv_fish_mode disable_arrow

1
conf.d/eza.fish Normal file
View File

@ -0,0 +1 @@
alias ls eza

1
conf.d/flutter.fish Normal file
View File

@ -0,0 +1 @@
fish_add_path $HOME/.local/flutter/bin

5
conf.d/fzf.fish Normal file
View File

@ -0,0 +1,5 @@
source /usr/share/fzf/shell/key-bindings.fish
set -gx FZF_DEFAULT_COMMAND 'fd --type file . $dir'
set -gx FZF_CTRL_T_COMMAND $FZF_DEFAULT_COMMAND
set -gx FZF_ALT_C_COMMAND 'fd --type directory . $dir'

4
conf.d/git.fish Normal file
View File

@ -0,0 +1,4 @@
# Why doesnt breeze provide this?
alias grc 'git rebase --continue'
bind \eg __show_git_status

2
conf.d/go.fish Normal file
View File

@ -0,0 +1,2 @@
set -gx GOPATH $HOME/.local/go
fish_add_path $HOME/.local/go/bin

8
conf.d/gpg-agent.fish Normal file
View File

@ -0,0 +1,8 @@
# Gnome Keyring can (and will) mess up SSH_AUTH_SOCK, but we cant simply overwrite it, because auth forwarding mangles
# it, too
if not set -q SSH_AUTH_SOCK or string match -q "$HOME/.cache/keyring-*/ssh" $SSH_AUTH_SOCK
set -gx SSH_AUTH_SOCK $XDG_RUNTIME_DIR/gnupg/S.gpg-agent.ssh
end
set -gx GPG_TTY (tty)
#gpg-connect-agent updatestartuptty /bye > /dev/null

4
conf.d/node.fish Normal file
View File

@ -0,0 +1,4 @@
set -gx NPM_PACKAGES $HOME/.local/node
fish_add_path $HOME/.local/npm-packages/bin
fish_add_path $HOME/.local/node/bin
set -gx MANPATH $HOME/.local/node/share/man:(manpath -q)

View File

@ -0,0 +1,24 @@
if test "$NEED_WSL_SOCAT" = "1"
# WSL Socket forwarding
if begin
status is-interactive; and string sub (uname -r) WSL >/dev/null
end
# Commands to run in interactive sessions can go here
# Channel Pageant to WSL2
set -x SSH_AUTH_SOCK "$HOME/.ssh/agent.sock"
if not ss -a | grep -q "$SSH_AUTH_SOCK"
rm -f "$SSH_AUTH_SOCK"
set wsl2_ssh_pageant_bin "$HOME/.ssh/wsl2-ssh-pageant.exe"
if test -x "$wsl2_ssh_pageant_bin"
setsid nohup socat UNIX-LISTEN:"$SSH_AUTH_SOCK,fork" EXEC:"$wsl2_ssh_pageant_bin" >/dev/null 2>&1 &
else
echo >&2 "WARNING: $wsl2_ssh_pageant_bin is not executable."
end
set --erase wsl2_ssh_pageant_bin
end
# machina
else if not set -q SSH_AUTH_SOCK or string match -q "$HOME/.cache/keyring-*/ssh" $SSH_AUTH_SOCK
set -gx SSH_AUTH_SOCK {$XDG_RUNTIME_DIR}gnupg/S.gpg-agent.ssh
end
end

1
conf.d/rust.fish Normal file
View File

@ -0,0 +1 @@
fish_add_path $HOME/.cargo/bin

1
conf.d/sway.fish Normal file
View File

@ -0,0 +1 @@
set -gx SWAY_CURSOR_THEME Adwaita

6
conf.d/tmux.fish Normal file
View File

@ -0,0 +1,6 @@
# If running in interactive mode and not within
# TMUX, start TMUX instead. `tmux-default` is a
# shell script within PATH that either connects to
# the "default" session, or creates one if it
# doesnt exst yet
#status --is-interactive; and test $TERM != "screen" -a $TERM != "screen-256color"; and exec tmux-default

1
conf.d/vagrant.fish Normal file
View File

@ -0,0 +1 @@
set -gx VAGRANT_DEFAULT_PROVIDER libvirt

1
conf.d/watch-prefix.fish Normal file
View File

@ -0,0 +1 @@
bind --preset \ew 'fish_commandline_prepend watch'

1
conf.d/zoxide.fish Normal file
View File

@ -0,0 +1 @@
zoxide init fish | source

14
config.fish Normal file
View File

@ -0,0 +1,14 @@
fish_add_path --append /usr/sbin
test -x $HOME/.local/bin/update-xdg-data-dirs.py; and set -gx XDG_DATA_DIRS ($HOME/.local/bin/update-xdg-data-dirs.py)
# My own stuff
fish_add_path --prepend $HOME/bin
fish_add_path --prepend $HOME/.local/bin
set -gx EDITOR ec
set uds (command -v update-default-soundcard)
if test -n "$uds" -a -x "$uds"
$uds
end

5
fish_plugins Normal file
View File

@ -0,0 +1,5 @@
jorgebucaran/getopts.fish
edc/bass
jorgebucaran/fisher
shinriyo/breeze
ilancosman/tide@v5

140
functions/__bass.py Normal file
View File

@ -0,0 +1,140 @@
"""
To be used with a companion fish function like this:
function refish
set -l _x (python /tmp/bass.py source ~/.nvm/nvim.sh ';' nvm use iojs); source $_x; and rm -f $_x
end
"""
from __future__ import print_function
import json
import os
import signal
import subprocess
import sys
import traceback
BASH = 'bash'
FISH_READONLY = [
'PWD', 'SHLVL', 'history', 'pipestatus', 'status', 'version',
'FISH_VERSION', 'fish_pid', 'hostname', '_', 'fish_private_mode'
]
IGNORED = [
'PS1', 'XPC_SERVICE_NAME'
]
def ignored(name):
if name == 'PWD': # this is read only, but has special handling
return False
# ignore other read only variables
if name in FISH_READONLY:
return True
if name in IGNORED or name.startswith("BASH_FUNC"):
return True
if name.startswith('%'):
return True
return False
def escape(string):
# use json.dumps to reliably escape quotes and backslashes
return json.dumps(string).replace(r'$', r'\$')
def escape_identifier(word):
return escape(word.replace('?', '\\?'))
def comment(string):
return '\n'.join(['# ' + line for line in string.split('\n')])
def gen_script():
# Use the following instead of /usr/bin/env to read environment so we can
# deal with multi-line environment variables (and other odd cases).
env_reader = "%s -c 'import os,json; print(json.dumps({k:v for k,v in os.environ.items()}))'" % (sys.executable)
args = [BASH, '-c', env_reader]
output = subprocess.check_output(args, universal_newlines=True)
old_env = output.strip()
pipe_r, pipe_w = os.pipe()
if sys.version_info >= (3, 4):
os.set_inheritable(pipe_w, True)
command = 'eval $1 && ({}; alias) >&{}'.format(
env_reader,
pipe_w
)
args = [BASH, '-c', command, 'bass', ' '.join(sys.argv[1:])]
p = subprocess.Popen(args, universal_newlines=True, close_fds=False)
os.close(pipe_w)
with os.fdopen(pipe_r) as f:
new_env = f.readline()
alias_str = f.read()
if p.wait() != 0:
raise subprocess.CalledProcessError(
returncode=p.returncode,
cmd=' '.join(sys.argv[1:]),
output=new_env + alias_str
)
new_env = new_env.strip()
old_env = json.loads(old_env)
new_env = json.loads(new_env)
script_lines = []
for k, v in new_env.items():
if ignored(k):
continue
v1 = old_env.get(k)
if not v1:
script_lines.append(comment('adding %s=%s' % (k, v)))
elif v1 != v:
script_lines.append(comment('updating %s=%s -> %s' % (k, v1, v)))
# process special variables
if k == 'PWD':
script_lines.append('cd %s' % escape(v))
continue
else:
continue
if k == 'PATH':
value = ' '.join([escape(directory)
for directory in v.split(':')])
else:
value = escape(v)
script_lines.append('set -g -x %s %s' % (k, value))
for var in set(old_env.keys()) - set(new_env.keys()):
script_lines.append(comment('removing %s' % var))
script_lines.append('set -e %s' % var)
script = '\n'.join(script_lines)
alias_lines = []
for line in alias_str.splitlines():
_, rest = line.split(None, 1)
k, v = rest.split("=", 1)
alias_lines.append("alias " + escape_identifier(k) + "=" + v)
alias = '\n'.join(alias_lines)
return script + '\n' + alias
script_file = os.fdopen(3, 'w')
if not sys.argv[1:]:
print('__bass_usage', file=script_file, end='')
sys.exit(0)
try:
script = gen_script()
except subprocess.CalledProcessError as e:
sys.exit(e.returncode)
except Exception:
print('Bass internal error!', file=sys.stderr)
raise # traceback will output to stderr
except KeyboardInterrupt:
signal.signal(signal.SIGINT, signal.SIG_DFL)
os.kill(os.getpid(), signal.SIGINT)
else:
script_file.write(script)

View File

@ -0,0 +1,7 @@
function __breeze_variables
# This function doesn't need to do anything, we just have this file here to ensure autoloading only sets $arr & $op up once
end
# for global
set -g -x arr ""
set -g -x op ""

View File

@ -0,0 +1,22 @@
# This function should be bound to Alt-G, and is used to show the current git status of the directory inder the cursor.
function __show_git_status -d "Show git status at token under the cursor if it is a directory, or the current directory"
set -l target (commandline -t)
printf "\n"
if test ! -d $target
set -l dir (dirname -- $target)
if test $dir != . -a -d $dir
set target $dir
else
set target .
end
end
git -C $target rev-parse &>/dev/null
and git -C $target status
or echo "Not a Git repository"
string repeat -N \n --count=(math (count (fish_prompt)) - 1)
commandline -f repaint
end

View File

@ -0,0 +1,3 @@
function __title_case -a string
echo $string | sed 's/^/ /;s/ [aA]/ A/g;s/ [bB]/ B/g;s/ [cC]/ C/g;s/ [dD]/ D/g;s/ [eE]/ E/g;s/ [fF]/ F/g;s/ [gG]/ G/g;s/ [hH]/ H/g;s/ [iI]/ I/g;s/ [jJ]/ J/g;s/ [kK]/ K/g;s/ [lL]/ L/g;s/ [mM]/ M/g;s/ [nN]/ N/g;s/ [oO]/ O/g;s/ [pP]/ P/g;s/ [qQ]/ Q/g;s/ [rR]/ R/g;s/ [sS]/ S/g;s/ [tT]/ T/g;s/ [uU]/ U/g;s/ [vV]/ V/g;s/ [wW]/ W/g;s/ [xX]/ X/g;s/ [yY]/ Y/g;s/ [zZ]/ Z/g;s/^.//'
end

View File

@ -0,0 +1,19 @@
function _tide_1_line_prompt
set -g add_prefix
_tide_side=left for item in $_tide_left_items
_tide_item_$item
end
set_color $prev_bg_color -b normal
echo $tide_left_prompt_suffix
set -g add_prefix
_tide_side=right for item in $_tide_right_items
_tide_item_$item
end
set_color $prev_bg_color -b normal
echo $tide_right_prompt_suffix
end
function _tide_item_pwd
_tide_print_item pwd @PWD@
end

View File

@ -0,0 +1,31 @@
function _tide_2_line_prompt
set -g add_prefix
_tide_side=left for item in $_tide_left_items
_tide_item_$item
end
if not set -e add_prefix
set_color $prev_bg_color -b normal
echo $tide_left_prompt_suffix
end
echo
set -g add_prefix
_tide_side=right for item in $_tide_right_items
_tide_item_$item
end
if not set -e add_prefix
set_color $prev_bg_color -b normal
echo $tide_right_prompt_suffix
end
end
function _tide_item_pwd
_tide_print_item pwd @PWD@
end
function _tide_item_newline
set_color $prev_bg_color -b normal
v=tide_"$_tide_side"_prompt_suffix echo $$v
set -g add_prefix
end

View File

@ -0,0 +1,17 @@
function _tide_cache_variables
# Same-color-separator color
set_color $tide_prompt_color_separator_same_color | read -gx _tide_color_separator_same_color
# git
contains git $_tide_left_items $_tide_right_items && set_color $tide_git_color_branch | read -gx _tide_location_color
# private_mode
if contains private_mode $_tide_left_items $_tide_right_items && test -n "$fish_private_mode"
set -gx _tide_private_mode
else
set -e _tide_private_mode
end
# item padding
test "$tide_prompt_pad_items" = true && set -gx _tide_pad ' ' || set -e _tide_pad
end

View File

@ -0,0 +1,75 @@
# Outputs icon, color, bg_color
function _tide_detect_os
set -lx defaultColor 080808 CED7CF
switch (uname | string lower)
case darwin
printf %s\n  D6D6D6 333333 # from apple.com header
case freebsd openbsd dragonfly
printf %s\n  FFFFFF AB2B28 # https://freebsdfoundation.org/about-us/about-the-foundation/project/
case 'cygwin*' 'mingw*_nt*' 'msys_nt*'
printf %s\n  FFFFFF 00CCFF # https://answers.microsoft.com/en-us/windows/forum/all/what-is-the-official-windows-8-blue-rgb-or-hex/fd57144b-f69b-42d8-8c21-6ca911646e44
case linux
if test (uname -o) = Android
echo ﲎ # This character is evil and messes up code display, so it's put on its own line
# https://developer.android.com/distribute/marketing-tools/brand-guidelines
printf %s\n 3DDC84 3C3F41 # fg is from above link, bg is from Android Studio default dark theme
else
_tide_detect_os_linux_cases /etc/os-release ID ||
_tide_detect_os_linux_cases /etc/os-release ID_LIKE ||
_tide_detect_os_linux_cases /etc/lsb-release DISTRIB_ID ||
printf %s\n$defaultColor
end
case '*'
echo -ns '?'
end
end
function _tide_detect_os_linux_cases -a file key
test -e $file || return
set -l split_file (string split '=' <$file)
set -l key_index (contains --index $key $split_file) || return
set -l value (string trim --chars='"' $split_file[(math $key_index + 1)])
# Anything which would have pure white background has been changed to D4D4D4
# It was just too bright otherwise
switch (string lower $value)
case alpine
printf %s\n  FFFFFF 0D597F # from alpine logo
case arch
printf %s\n  1793D1 4D4D4D # from arch wiki header
case centos
printf %s\n000000 D4D4D4 # https://wiki.centos.org/ArtWork/Brand/Logo, monochromatic
case debian
printf %s\n  C70036 D4D4D4 # from debian logo https://www.debian.org/logos/openlogo-nd-100.png
case devuan
printf %s\n$defaultColor # logo is monochromatic
case elementary
printf %s\n000000 D4D4D4 # https://elementary.io/brand, encouraged to be monochromatic
case fedora
printf %s\n  FFFFFF 294172 # from logo https://fedoraproject.org/w/uploads/2/2d/Logo_fedoralogo.png
case gentoo
printf %s\n  FFFFFF 54487A # https://wiki.gentoo.org/wiki/Project:Artwork/Colors
case mageia
printf %s\n  FFFFFF 262F45 # https://wiki.mageia.org/en/Artwork_guidelines
case manjaro
printf %s\n  FFFFFF 35BF5C # from https://gitlab.manjaro.org/artwork/branding/logo/-/blob/master/logo.svg
case mint linuxmint
printf %s\n  FFFFFF 69B53F # extracted from https://linuxmint.com/web/img/favicon.ico
case nixos
printf %s\n  FFFFFF 5277C3 # https://github.com/NixOS/nixos-artwork/tree/master/logo
case opensuse-leap opensuse-tumbleweed opensuse-microos
printf %s\n  73BA25 173f4f # https://en.opensuse.org/openSUSE:Artwork_brand
case raspbian
printf %s\n  FFFFFF A22846 # https://static.raspberrypi.org/files/Raspberry_Pi_Visual_Guidelines_2020.pdf
case rhel
printf %s\n  EE0000 000000 # https://www.redhat.com/en/about/brand/standards/color
case sabayon
printf %s\n$defaultColor # Can't find colors, and they are rebranding anyway
case slackware
printf %s\n$defaultColor # Doesn't really have a logo, and the colors are too close to PWD blue anyway
case ubuntu
printf %s\n  E95420 D4D4D4 # https://design.ubuntu.com/brand/
case '*'
return 1
end
end

View File

@ -0,0 +1,3 @@
function _tide_find_and_remove -a name list --no-scope-shadowing
contains --index $name $$list | read -l index && set -e "$list"[$index]
end

View File

@ -0,0 +1,11 @@
function _tide_item_aws
# AWS_PROFILE overrides AWS_DEFAULT_PROFILE, AWS_REGION overrides AWS_DEFAULT_REGION
set -q AWS_PROFILE && set -l AWS_DEFAULT_PROFILE $AWS_PROFILE
set -q AWS_REGION && set -l AWS_DEFAULT_REGION $AWS_REGION
if test -n "$AWS_DEFAULT_PROFILE" && test -n "$AWS_DEFAULT_REGION"
_tide_print_item aws $tide_aws_icon' ' "$AWS_DEFAULT_PROFILE/$AWS_DEFAULT_REGION"
else if test -n "$AWS_DEFAULT_PROFILE$AWS_DEFAULT_REGION"
_tide_print_item aws $tide_aws_icon' ' "$AWS_DEFAULT_PROFILE$AWS_DEFAULT_REGION"
end
end

View File

@ -0,0 +1,17 @@
function _tide_item_character
test $_tide_status = 0 && set_color $tide_character_color || set_color $tide_character_color_failure
set -q add_prefix || echo -ns ' '
test "$fish_key_bindings" = fish_default_key_bindings && echo -ns $tide_character_icon ||
switch $fish_bind_mode
case insert
echo -ns $tide_character_icon
case default
echo -ns $tide_character_vi_icon_default
case replace replace_one
echo -ns $tide_character_vi_icon_replace
case visual
echo -ns $tide_character_vi_icon_visual
end
end

View File

@ -0,0 +1,3 @@
function _tide_item_chruby
test -n "$RUBY_VERSION" && _tide_print_item chruby $tide_chruby_icon' ' $RUBY_VERSION
end

View File

@ -0,0 +1,12 @@
function _tide_item_cmd_duration
test $CMD_DURATION -gt $tide_cmd_duration_threshold && t=(
math -s0 "$CMD_DURATION/3600000" # Hours
math -s0 "$CMD_DURATION/60000"%60 # Minutes
math -s$tide_cmd_duration_decimals "$CMD_DURATION/1000"%60) if test $t[1] != 0
_tide_print_item cmd_duration $tide_cmd_duration_icon' ' "$t[1]h $t[2]m $t[3]s"
else if test $t[2] != 0
_tide_print_item cmd_duration $tide_cmd_duration_icon' ' "$t[2]m $t[3]s"
else
_tide_print_item cmd_duration $tide_cmd_duration_icon' ' "$t[3]s"
end
end

View File

@ -0,0 +1,15 @@
function _tide_item_context
if set -q SSH_TTY
set -lx tide_context_color $tide_context_color_ssh
test "$tide_context_hostname_parts" = 0 && _tide_print_item context $USER ||
h=(string split . $hostname) _tide_print_item context $USER@(string join . $h[..$tide_context_hostname_parts])
else if test "$EUID" = 0
set -lx tide_context_color $tide_context_color_root
test "$tide_context_hostname_parts" = 0 && _tide_print_item context $USER ||
h=(string split . $hostname) _tide_print_item context $USER@(string join . $h[..$tide_context_hostname_parts])
else if test "$tide_context_always_display" = true
set -lx tide_context_color $tide_context_color_default
test "$tide_context_hostname_parts" = 0 && _tide_print_item context $USER ||
h=(string split . $hostname) _tide_print_item context $USER@(string join . $h[..$tide_context_hostname_parts])
end
end

View File

@ -0,0 +1,4 @@
function _tide_item_crystal
path is $_tide_parent_dirs/shard.yml &&
_tide_print_item crystal $tide_crystal_icon' ' (crystal --version | string match -r "[\d.]+")[1]
end

View File

@ -0,0 +1,7 @@
function _tide_item_direnv
set -q DIRENV_DIR || return
direnv status | string match -q 'Found RC allowed false' \
&& set -lx tide_direnv_color $tide_direnv_color_denied \
&& set -lx tide_direnv_bg_color $tide_direnv_bg_color_denied
_tide_print_item direnv $tide_direnv_icon
end

View File

@ -0,0 +1,4 @@
function _tide_item_distrobox
test -e /etc/profile.d/distrobox_profile.sh && test -e /run/.containerenv &&
_tide_print_item distrobox $tide_distrobox_icon' ' (string match -rg 'name="(.*)"' </run/.containerenv)
end

View File

@ -0,0 +1,5 @@
function _tide_item_docker
docker context inspect --format '{{.Name}}' | read -l context
contains -- "$context" $tide_docker_default_contexts ||
_tide_print_item docker $tide_docker_icon' ' $context
end

View File

@ -0,0 +1,4 @@
function _tide_item_elixir
path is $_tide_parent_dirs/mix.exs &&
_tide_print_item elixir $tide_elixir_icon' ' (elixir --short-version)
end

View File

@ -0,0 +1,8 @@
function _tide_item_gcloud
set -q CLOUDSDK_CONFIG || set -l CLOUDSDK_CONFIG ~/.config/gcloud
path is $CLOUDSDK_CONFIG/active_config \
&& read -l config <$CLOUDSDK_CONFIG/active_config \
&& path is $CLOUDSDK_CONFIG/configurations/config_$config \
&& string match -qr '^\s*project\s*=\s*(?<project>.*)' <$CLOUDSDK_CONFIG/configurations/config_$config \
&& _tide_print_item gcloud $tide_gcloud_icon' ' $project
end

View File

@ -0,0 +1,67 @@
function _tide_item_git
if git branch --show-current 2>/dev/null | string shorten -"$tide_git_truncation_strategy"m$tide_git_truncation_length | read -l location
git rev-parse --git-dir --is-inside-git-dir | read -fL gdir in_gdir
set location $_tide_location_color$location
else if test $pipestatus[1] != 0
return
else if git tag --points-at HEAD | string shorten -"$tide_git_truncation_strategy"m$tide_git_truncation_length | read location
git rev-parse --git-dir --is-inside-git-dir | read -fL gdir in_gdir
set location '#'$_tide_location_color$location
else
git rev-parse --git-dir --is-inside-git-dir --short HEAD | read -fL gdir in_gdir location
set location @$_tide_location_color$location
end
# Operation
if test -d $gdir/rebase-merge
read -f step <$gdir/rebase-merge/msgnum
read -f total_steps <$gdir/rebase-merge/end
test -f $gdir/rebase-merge/interactive && set -f operation rebase-i || set -f operation rebase-m
else if test -d $gdir/rebase-apply
read -f step <$gdir/rebase-apply/next
read -f total_steps <$gdir/rebase-apply/last
if test -f $gdir/rebase-apply/rebasing
set -f operation rebase
else if test -f $gdir/rebase-apply/applying
set -f operation am
else
set -f operation am/rebase
end
else if test -f $gdir/MERGE_HEAD
set -f operation merge
else if test -f $gdir/CHERRY_PICK_HEAD
set -f operation cherry-pick
else if test -f $gdir/REVERT_HEAD
set -f operation revert
else if test -f $gdir/BISECT_LOG
set -f operation bisect
end
# Git status/stash + Upstream behind/ahead
test $in_gdir = true && set -l _set_dir_opt -C $gdir/..
# Suppress errors in case we are in a bare repo or there is no upstream
set -l stat (git $_set_dir_opt --no-optional-locks status --porcelain 2>/dev/null)
string match -qr '(0|(?<stash>.*))\n(0|(?<conflicted>.*))\n(0|(?<staged>.*))
(0|(?<dirty>.*))\n(0|(?<untracked>.*))(\n(0|(?<behind>.*))\t(0|(?<ahead>.*)))?' \
"$(git $_set_dir_opt stash list 2>/dev/null | count
string match -r ^UU $stat | count
string match -r ^[ADMR]. $stat | count
string match -r ^.[ADMR] $stat | count
string match -r '^\?\?' $stat | count
git rev-list --count --left-right @{upstream}...HEAD 2>/dev/null)"
if test -n "$operation$conflicted"
set -g tide_git_bg_color $tide_git_bg_color_urgent
else if test -n "$staged$dirty$untracked"
set -g tide_git_bg_color $tide_git_bg_color_unstable
end
_tide_print_item git $_tide_location_color$tide_git_icon' ' (set_color white; echo -ns $location
set_color $tide_git_color_operation; echo -ns ' '$operation ' '$step/$total_steps
set_color $tide_git_color_upstream; echo -ns ' ⇣'$behind ' ⇡'$ahead
set_color $tide_git_color_stash; echo -ns ' *'$stash
set_color $tide_git_color_conflicted; echo -ns ' ~'$conflicted
set_color $tide_git_color_staged; echo -ns ' +'$staged
set_color $tide_git_color_dirty; echo -ns ' !'$dirty
set_color $tide_git_color_untracked; echo -ns ' ?'$untracked)
end

View File

@ -0,0 +1,4 @@
function _tide_item_go
path is $_tide_parent_dirs/go.mod &&
_tide_print_item go $tide_go_icon' ' (go version | string match -r "[\d.]+")
end

View File

@ -0,0 +1,4 @@
function _tide_item_java
path is $_tide_parent_dirs/pom.xml &&
_tide_print_item java $tide_java_icon' ' (java -version &| string match -r "[\d.]+")[1]
end

View File

@ -0,0 +1,3 @@
function _tide_item_jobs
set -q _tide_jobs && _tide_print_item jobs $tide_jobs_icon
end

View File

@ -0,0 +1,4 @@
function _tide_item_kubectl
kubectl config view --minify --output 'jsonpath={.current-context}/{..namespace}' 2>/dev/null | read -l context &&
_tide_print_item kubectl $tide_kubectl_icon' ' (string replace -r '/(|default)$' '' $context)
end

View File

@ -0,0 +1,4 @@
function _tide_item_menv
menv 2>/dev/null | read -l env &&
_tide_print_item menv "" $env
end

View File

@ -0,0 +1,3 @@
function _tide_item_nix_shell
set -q IN_NIX_SHELL && _tide_print_item nix_shell $tide_nix_shell_icon' ' $IN_NIX_SHELL
end

View File

@ -0,0 +1,4 @@
function _tide_item_node
path is $_tide_parent_dirs/package.json &&
_tide_print_item node $tide_node_icon' ' (node --version | string trim --chars=v)
end

View File

@ -0,0 +1,3 @@
function _tide_item_os
_tide_print_item os $tide_os_icon
end

View File

@ -0,0 +1,4 @@
function _tide_item_php
path is $_tide_parent_dirs/composer.json &&
_tide_print_item php $tide_php_icon' ' (php --version | string match -r 'PHP ([\d.]+)')[2]
end

View File

@ -0,0 +1,3 @@
function _tide_item_private_mode
set -q _tide_private_mode && _tide_print_item private_mode $tide_private_mode_icon
end

View File

@ -0,0 +1,19 @@
function _tide_item_pulumi
if path filter $_tide_parent_dirs/Pulumi.yaml | read -l yaml_path
if command -q sha1sum
echo -n "$yaml_path" | sha1sum | string sub -e40 | read -f path_hash
else if command -q shasum
echo -n "$yaml_path" | shasum | string sub -e40 | read -f path_hash
end
if test -n "$path_hash"
string match -rg 'name: *(.*)' <$yaml_path | read -l project_name
set -l workspace_file "$HOME/.pulumi/workspaces/$project_name-$path_hash-workspace.json"
if test -e $workspace_file
string match -rg '"stack": *"(.*)"' <$workspace_file | read -l stack
_tide_print_item pulumi $tide_pulumi_icon' ' $stack
end
end
end
end

View File

@ -0,0 +1,4 @@
function _tide_item_rustc
path is $_tide_parent_dirs/Cargo.toml &&
_tide_print_item rustc $tide_rustc_icon' ' (rustc --version | string split ' ')[2]
end

View File

@ -0,0 +1,4 @@
function _tide_item_shlvl
# Non-interactive shells do not increment SHLVL, so we don't need to subtract 1
test $SHLVL -gt $tide_shlvl_threshold && _tide_print_item shlvl $tide_shlvl_icon' ' $SHLVL
end

View File

@ -0,0 +1,15 @@
function _tide_item_status
if string match -qv 0 $_tide_pipestatus # If there is a failure anywhere in the pipestatus
if test "$_tide_pipestatus" = 1 # If simple failure
contains character $_tide_left_items || tide_status_bg_color=$tide_status_bg_color_failure \
tide_status_color=$tide_status_color_failure _tide_print_item status $tide_status_icon_failure' ' 1
else
fish_status_to_signal $_tide_pipestatus | string replace SIG '' | string join '|' | read -l out
test $_tide_status = 0 && _tide_print_item status $tide_status_icon' ' $out ||
tide_status_bg_color=$tide_status_bg_color_failure tide_status_color=$tide_status_color_failure \
_tide_print_item status $tide_status_icon_failure' ' $out
end
else if not contains character $_tide_left_items
_tide_print_item status $tide_status_icon
end
end

View File

@ -0,0 +1,6 @@
function _tide_item_terraform
if path is $_tide_parent_dirs/.terraform
terraform workspace show | read -l workspace
test $workspace != default && _tide_print_item terraform $tide_terraform_icon' ' $workspace
end
end

View File

@ -0,0 +1,3 @@
function _tide_item_time
_tide_print_item time (date +$tide_time_format)
end

View File

@ -0,0 +1,4 @@
function _tide_item_toolbox
test -e /run/.toolboxenv &&
_tide_print_item toolbox $tide_toolbox_icon' ' (string match -rg 'name="(.*)"' </run/.containerenv)
end

View File

@ -0,0 +1,16 @@
function _tide_item_vi_mode
test "$fish_key_bindings" != fish_default_key_bindings && switch $fish_bind_mode
case default
tide_vi_mode_bg_color=$tide_vi_mode_bg_color_default tide_vi_mode_color=$tide_vi_mode_color_default \
_tide_print_item vi_mode $tide_vi_mode_icon_default
case insert
tide_vi_mode_bg_color=$tide_vi_mode_bg_color_insert tide_vi_mode_color=$tide_vi_mode_color_insert \
_tide_print_item vi_mode $tide_vi_mode_icon_insert
case replace replace_one
tide_vi_mode_bg_color=$tide_vi_mode_bg_color_replace tide_vi_mode_color=$tide_vi_mode_color_replace \
_tide_print_item vi_mode $tide_vi_mode_icon_replace
case visual
tide_vi_mode_bg_color=$tide_vi_mode_bg_color_visual tide_vi_mode_color=$tide_vi_mode_color_visual \
_tide_print_item vi_mode $tide_vi_mode_icon_visual
end
end

View File

@ -0,0 +1,11 @@
function _tide_item_virtual_env
test -n "$VIRTUAL_ENV" && split_virtual_env=(string split / "$VIRTUAL_ENV") if test $split_virtual_env[-2] = virtualenvs
# pipenv $VIRTUAL_ENV looks like /home/ilan/.local/share/virtualenvs/pipenv_project-EwRYuc3l
# Detect whether we are using pipenv by looking for virtualenvs. If so, remove the hash at the end.
_tide_print_item virtual_env $tide_virtual_env_icon' ' (string split -r -m1 - "$split_virtual_env[-1]")[1]
else if contains -- $split_virtual_env[-1] virtualenv venv .venv env # avoid generic names
_tide_print_item virtual_env $tide_virtual_env_icon' ' $split_virtual_env[-2]
else
_tide_print_item virtual_env $tide_virtual_env_icon' ' $split_virtual_env[-1]
end
end

View File

@ -0,0 +1,7 @@
function _tide_parent_dirs --on-variable PWD
set -g _tide_parent_dirs (string escape (
for dir in (string split / -- $PWD)
set -la parts $dir
string join / -- $parts
end))
end

View File

@ -0,0 +1,22 @@
function _tide_print_item -a item
v=tide_"$item"_bg_color set -f item_bg_color $$v
if set -e add_prefix
set_color $item_bg_color -b normal
v=tide_"$_tide_side"_prompt_prefix echo -ns $$v
else if test "$item_bg_color" = "$prev_bg_color"
v=tide_"$_tide_side"_prompt_separator_same_color echo -ns $_tide_color_separator_same_color$$v
else if test $_tide_side = left
set_color $prev_bg_color -b $item_bg_color
echo -ns $tide_left_prompt_separator_diff_color
else
set_color $item_bg_color -b $prev_bg_color
echo -ns $tide_right_prompt_separator_diff_color
end
v=tide_"$item"_color set_color $$v -b $item_bg_color
echo -ns $_tide_pad $argv[2..] $_tide_pad
set -g prev_bg_color $item_bg_color
end

38
functions/_tide_pwd.fish Normal file
View File

@ -0,0 +1,38 @@
set_color -o $tide_pwd_color_anchors | read -l color_anchors
set_color $tide_pwd_color_truncated_dirs | read -l color_truncated
set -l reset_to_color_dirs (set_color normal -b $tide_pwd_bg_color; set_color $tide_pwd_color_dirs)
set -l unwritable_icon $tide_pwd_icon_unwritable' '
set -l home_icon $tide_pwd_icon_home' '
set -l pwd_icon $tide_pwd_icon' '
eval "function _tide_pwd
if set -l split_pwd (string replace -r '^$HOME' '~' -- \$PWD | string split /)
test -w . && set -f split_output \"$pwd_icon\$split_pwd[1]\" \$split_pwd[2..] ||
set -f split_output \"$unwritable_icon\$split_pwd[1]\" \$split_pwd[2..]
set split_output[-1] \"$color_anchors\$split_output[-1]$reset_to_color_dirs\"
else
set -f split_output \"$home_icon$color_anchors~\"
end
string join / -- \$split_output | string length -V | read -g _tide_pwd_len
i=1 for dir_section in \$split_pwd[2..-2]
string join -- / \$split_pwd[..\$i] | string replace '~' $HOME | read -l parent_dir # Uses i before increment
math \$i+1 | read i
if path is \$parent_dir/\$dir_section/\$tide_pwd_markers
set split_output[\$i] \"$color_anchors\$dir_section$reset_to_color_dirs\"
else if test \$_tide_pwd_len -gt \$dist_btwn_sides
set -l trunc
string match -qr \"(?<trunc>\..|.)\" \$dir_section
while v=\$parent_dir/\$trunc*/ set -q v[2] && string match -qr \"(?<trunc>\$trunc.)\" \$dir_section
end
test -n \"\$trunc\" && set split_output[\$i] \"$color_truncated\$trunc$reset_to_color_dirs\" &&
string join / \$split_output | string length -V | read _tide_pwd_len
end
end
string join -- / \"$reset_to_color_dirs\$split_output[1]\" \$split_output[2..]
end"

View File

@ -0,0 +1,25 @@
function _tide_remove_unusable_items
# Remove tool-specific items for tools the machine doesn't have installed
set -l removed_items
for item in aws chruby crystal direnv distrobox docker elixir gcloud git go java kubectl nix_shell node php pulumi rustc terraform toolbox virtual_env
contains $item $tide_left_prompt_items $tide_right_prompt_items || continue
set -l cli_names $item
switch $item
case distrobox # there is no 'distrobox' command inside the container
set cli_names distrobox-export # 'distrobox-export' and 'distrobox-host-exec' are available
case virtual_env
set cli_names python python3
case nix_shell
set cli_names nix nix-shell
end
type --query $cli_names || set -a removed_items $item
end
set -U _tide_left_items (for item in $tide_left_prompt_items
contains $item $removed_items || echo $item
end)
set -U _tide_right_items (for item in $tide_right_prompt_items
contains $item $removed_items || echo $item
end)
end

View File

@ -0,0 +1,73 @@
function _tide_sub_bug-report
argparse c/clean v/verbose check -- $argv
set -l fish_path (status fish-path)
if set -q _flag_clean
HOME=(mktemp -d) $fish_path --init-command "curl --silent \
https://raw.githubusercontent.com/jorgebucaran/fisher/main/functions/fisher.fish |
source && fisher install ilancosman/tide@v5"
else if set -q _flag_verbose
set --long | string match -r "^_?tide.*" | # Get only tide variables
string match -r --invert "^_tide_prompt_var.*" # Remove _tide_prompt_var
else
set -l fish_version ($fish_path --version | string match -r "fish, version (\d\.\d\.\d)")[2]
_tide_check_version Fish fish-shell/fish-shell "(\d\.\d\.\d)" $fish_version || return
set -l tide_version (tide --version | string match -r "tide, version (\d\.\d\.\d)")[2]
_tide_check_version Tide IlanCosman/tide "v(\d\.\d\.\d)" $tide_version || return
if command --query git
test (git --version | string match -r "git version ([\d\.]*)" | string replace --all . '')[2] -gt 2220
_tide_check_condition \
"Your git version is too old." \
"Tide requires at least version 2.22." \
"Please update before submitting a bug report." || return
end
# Check that omf is not installed
not functions --query omf
_tide_check_condition \
"Tide does not work with oh-my-fish installed." \
"Please uninstall it before submitting a bug report." || return
if not set -q _flag_check
set -l fish_startup_time ($fish_path -ic "time $fish_path -c exit" 2>|
string match -r "Executed in(.*)fish" | string trim)[2]
read --local --prompt-str "What operating system are you using? (e.g Ubuntu 20.04): " os
read --local --prompt-str "What terminal emulator are you using? (e.g Kitty): " terminal_emulator
printf '%b\n' "\nPlease copy the following information into the issue:\n" \
"fish version: $fish_version" \
"tide version: $tide_version" \
"term: $TERM" \
"os: $os" \
"terminal emulator: $terminal_emulator" \
"fish startup: $fish_startup_time" \
"fisher plugins: $_fisher_plugins"
end
end
end
function _tide_check_version -a program_name repo_name regex_to_get_version current_version
curl --silent https://github.com/$repo_name/releases/latest |
string match -r ".*$repo_name/releases/tag/$regex_to_get_version.*" |
read --local --line __ latestVersion
string match --quiet -r "^$latestVersion" "$current_version"
_tide_check_condition \
"Your $program_name version is out of date." \
"The latest is $latestVersion. You have $current_version." \
"Please update before submitting a bug report."
end
function _tide_check_condition
if test "$status" != 0
set_color red
printf '%s\n' $argv
set_color normal
return 1
end
return 0
end

View File

@ -0,0 +1,95 @@
set -g _tide_color_dark_blue 0087AF
set -g _tide_color_dark_green 5FAF00
set -g _tide_color_gold D7AF00
set -g _tide_color_green 5FD700
set -g _tide_color_light_blue 00AFFF
# Create an empty fake function for each item
for func in _fake(functions --all | string match --entire _tide_item)
function $func
end
end
for file in (status dirname)/tide/configure/{choices, functions}/**.fish
source $file
end
function _tide_sub_configure
if test $COLUMNS -lt 55 -o $LINES -lt 21
echo 'Terminal size too small; must be at least 55 x 21'
return 1
end
_tide_detect_os | read -g --line os_branding_icon os_branding_color os_branding_bg_color
set -g fake_columns $COLUMNS
test $fake_columns -gt 90 && set fake_columns 90
set -g fake_lines $LINES
set -g _tide_selected_option
_next_choice all/style
end
function _next_choice -a nextChoice
set -q _tide_selected_option || return 0
set -l cmd (string split '/' $nextChoice)[2]
$cmd
end
function _tide_title -a text
command -q clear && clear
set_color -o
string pad --width (math --scale=0 "$fake_columns/2" + (string length $text)/2) $text
set_color normal
end
function _tide_option -a symbol text
set -ga _tide_option_list $symbol
set_color -o
echo "($symbol) $text"
set_color normal
end
function _tide_menu
set -l list_with_slashes (string join '/' $_tide_option_list)
echo '(r) Restart from the beginning'
echo '(q) Quit and do nothing'\n
while true
set_color -o
read --nchars 1 --prompt-str "Choice [$list_with_slashes/r/q] " input
set_color normal
switch $input
case r
set -e _tide_option_list
_next_choice all/style
break
case q
set -e _tide_selected_option # Skip through all the _next_choices
set -e _tide_option_list
command -q clear && clear
break
case $_tide_option_list
set -e _tide_option_list
set -g _tide_selected_option $input
break
end
end
end
function _tide_display_prompt -a var_name var_value
test -n "$var_name" && set -g $var_name $var_value
_fake_tide_cache_variables
set -l prompt (_fake_tide_prompt)
set -l bottom_left_prompt_string_length (string length --visible $prompt[-1])
set -l right_prompt_string (string pad --width (math $fake_columns-$bottom_left_prompt_string_length) $prompt[1])
set -l prompt[-1] "$prompt[-1]$right_prompt_string"
string unescape $prompt[2..]
set_color normal
echo
end

29
functions/bass.fish Normal file
View File

@ -0,0 +1,29 @@
function bass
set -l bash_args $argv
set -l bass_debug
if test "$bash_args[1]_" = '-d_'
set bass_debug true
set -e bash_args[1]
end
set -l script_file (mktemp)
if command -v python3 >/dev/null 2>&1
command python3 -sS (dirname (status -f))/__bass.py $bash_args 3>$script_file
else
command python -sS (dirname (status -f))/__bass.py $bash_args 3>$script_file
end
set -l bass_status $status
if test $bass_status -ne 0
return $bass_status
end
if test -n "$bass_debug"
cat $script_file
end
source $script_file
command rm $script_file
end
function __bass_usage
echo "Usage: bass [-d] <bash-command>"
end

31
functions/bgas.fish Normal file
View File

@ -0,0 +1,31 @@
function bgas
set -l context (kubectl config current-context)
set -l cline
getopts $argv | while read -l key value
switch $key
case c
set context $value
case _
set cline $cline $value
end
end
set -l pod (
kubectl --context=$context --namespace=apps get pod -lapp=accounts-service,instance=app -o json |
jq -r '.items[].metadata.name' |
shuf |
head -1
)
if test -z "$pod"
echo "No pod found. Are you using the correct context?"
return 1
end
kubectl \
--context=$context \
--namespace=apps \
exec -ti $pod -- \
env SKIP_MIGRATION=yes ./docker-entrypoint.sh poetry run -- python3 -m assured_seal $cline
end

1
functions/br.fish Symbolic link
View File

@ -0,0 +1 @@
/home/polesz/.local/share/broot/launcher/fish/br.fish

2
functions/breeze.fish Normal file
View File

@ -0,0 +1,2 @@
function breeze -d "Shortcut tools for git command."
end

View File

@ -0,0 +1 @@
# Disable default vi prompt

View File

@ -0,0 +1,90 @@
function fish_prompt
end # In case this file gets loaded non-interactively, e.g by conda
status is-interactive || exit
_tide_remove_unusable_items
_tide_cache_variables
_tide_parent_dirs
source (functions --details _tide_pwd)
set -l prompt_var _tide_prompt_$fish_pid
set -U $prompt_var # Set var here so if we erase $prompt_var, bg job won't set a uvar
set_color normal | read -l color_normal
status fish-path | read -l fish_path
# _tide_repaint prevents us from creating a second background job
function _tide_refresh_prompt --on-variable $prompt_var --on-variable COLUMNS
set -g _tide_repaint
commandline -f repaint
end
if contains newline $_tide_left_items # two line prompt initialization
test "$tide_prompt_add_newline_before" = true && set -l add_newline '\n'
set_color $tide_prompt_color_frame_and_connection -b normal | read -l prompt_and_frame_color
set -l column_offset 5
test "$tide_left_prompt_frame_enabled" = true &&
set -l top_left_frame "$prompt_and_frame_color╭─" &&
set -l bot_left_frame "$prompt_and_frame_color╰─" &&
set column_offset (math $column_offset-2)
test "$tide_right_prompt_frame_enabled" = true &&
set -l top_right_frame "$prompt_and_frame_color─╮" &&
set -l bot_right_frame "$prompt_and_frame_color─╯" &&
set column_offset (math $column_offset-2)
eval "
function fish_prompt
_tide_status=\$status _tide_pipestatus=\$pipestatus if not set -e _tide_repaint
jobs -q && set -lx _tide_jobs
$fish_path -c \"set _tide_pipestatus \$_tide_pipestatus
set _tide_parent_dirs \$_tide_parent_dirs
PATH=\$(string escape \"\$PATH\") CMD_DURATION=\$CMD_DURATION fish_bind_mode=\$fish_bind_mode set $prompt_var (_tide_2_line_prompt)\" &
builtin disown
command kill \$_tide_last_pid 2>/dev/null
set -g _tide_last_pid \$last_pid
end
math \$COLUMNS-(string length -V \"\$$prompt_var[1][1]\$$prompt_var[1][3]\")+$column_offset | read -lx dist_btwn_sides
echo -ns $add_newline'$top_left_frame'(string replace @PWD@ (_tide_pwd) \"\$$prompt_var[1][1]\")'$prompt_and_frame_color'
string repeat -Nm(math max 0, \$dist_btwn_sides-\$_tide_pwd_len) '$tide_prompt_icon_connection'
echo -ns \"\$$prompt_var[1][3]$top_right_frame\"\n\"$bot_left_frame\$$prompt_var[1][2]$color_normal \"
end
function fish_right_prompt
string unescape \"\$$prompt_var[1][4]$bot_right_frame$color_normal\"
end"
else # one line prompt initialization
test "$tide_prompt_add_newline_before" = true && set -l add_newline '\0'
math 5 -$tide_prompt_min_cols | read -l column_offset
test $column_offset -ge 0 && set column_offset "+$column_offset"
eval "
function fish_prompt
_tide_status=\$status _tide_pipestatus=\$pipestatus if not set -e _tide_repaint
jobs -q && set -lx _tide_jobs
$fish_path -c \"set _tide_pipestatus \$_tide_pipestatus
set _tide_parent_dirs \$_tide_parent_dirs
PATH=\$(string escape \"\$PATH\") CMD_DURATION=\$CMD_DURATION fish_bind_mode=\$fish_bind_mode set $prompt_var (_tide_1_line_prompt)\" &
builtin disown
command kill \$_tide_last_pid 2>/dev/null
set -g _tide_last_pid \$last_pid
end
math \$COLUMNS-(string length -V \"\$$prompt_var[1][1]\$$prompt_var[1][2]\")$column_offset | read -lx dist_btwn_sides
string replace @PWD@ (_tide_pwd) $add_newline \$$prompt_var[1][1]'$color_normal '
end
function fish_right_prompt
string unescape \"\$$prompt_var[1][2]$color_normal\"
end"
end
eval "function _tide_on_fish_exit --on-event fish_exit
set -e $prompt_var
end"

240
functions/fisher.fish Normal file
View File

@ -0,0 +1,240 @@
function fisher --argument-names cmd --description "A plugin manager for Fish"
set --query fisher_path || set --local fisher_path $__fish_config_dir
set --local fisher_version 4.4.5
set --local fish_plugins $__fish_config_dir/fish_plugins
switch "$cmd"
case -v --version
echo "fisher, version $fisher_version"
case "" -h --help
echo "Usage: fisher install <plugins...> Install plugins"
echo " fisher remove <plugins...> Remove installed plugins"
echo " fisher update <plugins...> Update installed plugins"
echo " fisher update Update all installed plugins"
echo " fisher list [<regex>] List installed plugins matching regex"
echo "Options:"
echo " -v, --version Print version"
echo " -h, --help Print this help message"
echo "Variables:"
echo " \$fisher_path Plugin installation path. Default: $__fish_config_dir" | string replace --regex -- $HOME \~
case ls list
string match --entire --regex -- "$argv[2]" $_fisher_plugins
case install update remove
isatty || read --local --null --array stdin && set --append argv $stdin
set --local install_plugins
set --local update_plugins
set --local remove_plugins
set --local arg_plugins $argv[2..-1]
set --local old_plugins $_fisher_plugins
set --local new_plugins
test -e $fish_plugins && set --local file_plugins (string match --regex -- '^[^\s]+$' <$fish_plugins | string replace -- \~ ~)
if ! set --query argv[2]
if test "$cmd" != update
echo "fisher: Not enough arguments for command: \"$cmd\"" >&2 && return 1
else if ! set --query file_plugins
echo "fisher: \"$fish_plugins\" file not found: \"$cmd\"" >&2 && return 1
end
set arg_plugins $file_plugins
end
for plugin in $arg_plugins
set plugin (test -e "$plugin" && realpath $plugin || string lower -- $plugin)
contains -- "$plugin" $new_plugins || set --append new_plugins $plugin
end
if set --query argv[2]
for plugin in $new_plugins
if contains -- "$plugin" $old_plugins
test "$cmd" = remove &&
set --append remove_plugins $plugin ||
set --append update_plugins $plugin
else if test "$cmd" = install
set --append install_plugins $plugin
else
echo "fisher: Plugin not installed: \"$plugin\"" >&2 && return 1
end
end
else
for plugin in $new_plugins
contains -- "$plugin" $old_plugins &&
set --append update_plugins $plugin ||
set --append install_plugins $plugin
end
for plugin in $old_plugins
contains -- "$plugin" $new_plugins || set --append remove_plugins $plugin
end
end
set --local pid_list
set --local source_plugins
set --local fetch_plugins $update_plugins $install_plugins
set --local fish_path (status fish-path)
echo (set_color --bold)fisher $cmd version $fisher_version(set_color normal)
for plugin in $fetch_plugins
set --local source (command mktemp -d)
set --append source_plugins $source
command mkdir -p $source/{completions,conf.d,themes,functions}
$fish_path --command "
if test -e $plugin
command cp -Rf $plugin/* $source
else
set temp (command mktemp -d)
set repo (string split -- \@ $plugin) || set repo[2] HEAD
if set path (string replace --regex -- '^(https://)?gitlab.com/' '' \$repo[1])
set name (string split -- / \$path)[-1]
set url https://gitlab.com/\$path/-/archive/\$repo[2]/\$name-\$repo[2].tar.gz
else
set url https://api.github.com/repos/\$repo[1]/tarball/\$repo[2]
end
echo Fetching (set_color --underline)\$url(set_color normal)
if command curl -q --silent -L \$url | command tar -xzC \$temp -f - 2>/dev/null
command cp -Rf \$temp/*/* $source
else
echo fisher: Invalid plugin name or host unavailable: \\\"$plugin\\\" >&2
command rm -rf $source
end
command rm -rf \$temp
end
set files $source/* && string match --quiet --regex -- .+\.fish\\\$ \$files
" &
set --append pid_list (jobs --last --pid)
end
wait $pid_list 2>/dev/null
for plugin in $fetch_plugins
if set --local source $source_plugins[(contains --index -- "$plugin" $fetch_plugins)] && test ! -e $source
if set --local index (contains --index -- "$plugin" $install_plugins)
set --erase install_plugins[$index]
else
set --erase update_plugins[(contains --index -- "$plugin" $update_plugins)]
end
end
end
for plugin in $update_plugins $remove_plugins
if set --local index (contains --index -- "$plugin" $_fisher_plugins)
set --local plugin_files_var _fisher_(string escape --style=var -- $plugin)_files
if contains -- "$plugin" $remove_plugins
for name in (string replace --filter --regex -- '.+/conf\.d/([^/]+)\.fish$' '$1' $$plugin_files_var)
emit {$name}_uninstall
end
printf "%s\n" Removing\ (set_color red --bold)$plugin(set_color normal) " "$$plugin_files_var | string replace -- \~ ~
set --erase _fisher_plugins[$index]
end
command rm -rf (string replace -- \~ ~ $$plugin_files_var)
functions --erase (string replace --filter --regex -- '.+/functions/([^/]+)\.fish$' '$1' $$plugin_files_var)
for name in (string replace --filter --regex -- '.+/completions/([^/]+)\.fish$' '$1' $$plugin_files_var)
complete --erase --command $name
end
set --erase $plugin_files_var
end
end
if set --query update_plugins[1] || set --query install_plugins[1]
command mkdir -p $fisher_path/{functions,themes,conf.d,completions}
end
for plugin in $update_plugins $install_plugins
set --local source $source_plugins[(contains --index -- "$plugin" $fetch_plugins)]
set --local files $source/{functions,themes,conf.d,completions}/*
if set --local index (contains --index -- $plugin $install_plugins)
set --local user_files $fisher_path/{functions,themes,conf.d,completions}/*
set --local conflict_files
for file in (string replace -- $source/ $fisher_path/ $files)
contains -- $file $user_files && set --append conflict_files $file
end
if set --query conflict_files[1] && set --erase install_plugins[$index]
echo -s "fisher: Cannot install \"$plugin\": please remove or move conflicting files first:" \n" "$conflict_files >&2
continue
end
end
for file in (string replace -- $source/ "" $files)
command cp -RLf $source/$file $fisher_path/$file
end
set --local plugin_files_var _fisher_(string escape --style=var -- $plugin)_files
set --query files[1] && set --universal $plugin_files_var (string replace -- $source $fisher_path $files | string replace -- ~ \~)
contains -- $plugin $_fisher_plugins || set --universal --append _fisher_plugins $plugin
contains -- $plugin $install_plugins && set --local event install || set --local event update
printf "%s\n" Installing\ (set_color --bold)$plugin(set_color normal) " "$$plugin_files_var | string replace -- \~ ~
for file in (string match --regex -- '.+/[^/]+\.fish$' $$plugin_files_var | string replace -- \~ ~)
source $file
if set --local name (string replace --regex -- '.+conf\.d/([^/]+)\.fish$' '$1' $file)
emit {$name}_$event
end
end
end
command rm -rf $source_plugins
if set --query _fisher_plugins[1]
set --local commit_plugins
for plugin in $file_plugins
contains -- (string lower -- $plugin) (string lower -- $_fisher_plugins) && set --append commit_plugins $plugin
end
for plugin in $_fisher_plugins
contains -- (string lower -- $plugin) (string lower -- $commit_plugins) || set --append commit_plugins $plugin
end
string replace --regex -- $HOME \~ $commit_plugins >$fish_plugins
else
set --erase _fisher_plugins
command rm -f $fish_plugins
end
set --local total (count $install_plugins) (count $update_plugins) (count $remove_plugins)
test "$total" != "0 0 0" && echo (string join ", " (
test $total[1] = 0 || echo "Installed $total[1]") (
test $total[2] = 0 || echo "Updated $total[2]") (
test $total[3] = 0 || echo "Removed $total[3]")
) plugin/s
case \*
echo "fisher: Unknown command: \"$cmd\"" >&2 && return 1
end
end
if ! set --query _fisher_upgraded_to_4_4
set --universal _fisher_upgraded_to_4_4
if functions --query _fisher_list
set --query XDG_DATA_HOME[1] || set --local XDG_DATA_HOME ~/.local/share
command rm -rf $XDG_DATA_HOME/fisher
functions --erase _fisher_{list,plugin_parse}
fisher update >/dev/null 2>/dev/null
else
for var in (set --names | string match --entire --regex '^_fisher_.+_files$')
set $var (string replace -- ~ \~ $$var)
end
functions --erase _fisher_fish_postexec
end
end

78
functions/ga.fish Normal file
View File

@ -0,0 +1,78 @@
__breeze_variables
function __git_add -a var
set toplevel (git rev-parse --show-toplevel)
# is numeric
if [ "$var" -eq "$var" ] 2>/dev/null
# number
set myarg $arr[$var]
# -- (hyphen hyphen) compare
set hyphen (printf "%b" (printf '%s%x' '\x' 45))
if [ "$myarg" = "$hyphen$hyphen" ] 2>/dev/null
set myarg './'$myarg
end
git add $toplevel/$myarg
else
# not a number
git add $toplevel/$var
end
end
function __ga
# number
set res (string split "-" -- (string trim $argv))
set first $res[1]
set length (count $res)
set last ""
# >
if [ $length -gt 1 ]
set last $res[2]
# >
else
# just one
__git_add $res
return
end
# last exists
if [ $last != '' ]
set arr_length (count $arr)
# clamp as array length
if [ $arr_length -lt $last ]
set last $arr_length
end
# first < last
if [ $first -lt $last ]
for i in (seq $first 1 $last)
__git_add $i
end
else
echo 'Argument is not valid.'
end
else
__git_add $first
end
end
function ga
# space like, `ga 1 2 3`
set res (string split " " -- (string trim $argv))
set length (count $res)
# only one
if [ $length -eq 0 ]
__ga $argv
return
end
for i in $res
#echo $i
__ga $i
end
end

124
functions/gb.fish Normal file
View File

@ -0,0 +1,124 @@
__breeze_variables
function __git_branch -a var
# is numeric
if [ "$var" -eq "$var" ] 2>/dev/null
# number
set myarg $arr[$var]
# -- (hyphen hyphen) compare
set hyphen (printf "%b" (printf '%s%x' '\x' 45))
if [ "$myarg" = "$hyphen$hyphen" ] 2>/dev/null
set myarg './'$myarg
end
git branch $op $myarg
else
# not a number
git branch $op $var
end
end
function __gb
# number
# $argv[1] $argv[2..(count $argv)]
set res (string split "-" -- (string trim $argv))
set first $res[1]
set length (count $res)
set last ""
# >
if [ $length -gt 1 ]
set last $res[2]
# >
else
# just one
__git_branch $argv
return
end
# last exists
if [ $last != '' ]
set arr_length (count $arr)
# clamp as array length
if [ $arr_length -lt $last ]
set last $arr_length
end
# first < last
if [ $first -lt $last ]
for i in (seq $first 1 $last)
__git_branch $i
end
else
echo 'Argument is not valid.'
end
else
git branch $argv[1] $first
end
end
function gb
set op ""
set length (count $argv)
# >= 2
if [ $length -ge 2 ]
# more than 1
set fst (echo $argv[1] | string sub -l 1)
# if first string is -, it is option
if [ $fst = '-' ]
# option ex:-D
set op $argv[1]
set args $argv[2..(count $argv)]
__gb $args
return
end
end
set check_count (git branch)
set length (count $check_count)
if [ $length -gt 1 ]
# reset
set arr ""
end
# increment
set i 0
for item in (git branch)
#increment
set i (math $i + 1)
# check * contain
set res (string split " " -- (string trim $item))
set length (count $res)
# >
set is_contain true
set name ""
# more than one
if [ $length -gt 1 ]
# with *
set name (string trim $res[2])
else #only one
set name (string trim $item)
end
set arr[$i] $name
# *
if [ $length -gt 1 ]
# text without new line
echo -ne '* '
else
# just blank
echo -ne ' '
end
# text without new line
echo -ne [$i]' '
set_color green
echo $name
set_color normal
end
end

61
functions/gbl.fish Normal file
View File

@ -0,0 +1,61 @@
function __git_blame -a var
# is numeric
if [ "$var" -eq "$var" ] 2>/dev/null
# number
set myarg $arr[$var]
git blame $myarg
else
# not a number
git blame $var
end
end
function __gbl
# number
set res (string split "-" -- (string trim $argv))
set first $res[1]
set length (count $res)
set last ""
# >
if [ $length -gt 1 ]
set last $res[2]
else
# just one
__git_blame $myarg
return
end
# first < last
if [ $last != '' ]
if [ $first -lt $last ]
for i in (seq $first 1 $last)
__git_blame $i
end
else
echo 'argument is not valid.'
end
else
__git_blame $first
end
#echo $res[1]end
end
function gbl
echo '--'
# space like, `gbl 1 2 3`
echo $argv
set res (string split " " -- (string trim $argv))
set length (count $res)
echo $length
# only one
if [ $length -eq 0 ]
__gbl $argv
return
end
for i in $res
#echo $i
__ga $i
end
end

27
functions/gbu.fish Normal file
View File

@ -0,0 +1,27 @@
function __gbu
# number
set res (string split "-" -- (string trim $argv))
set length (count $res)
if [ $length -gt 0 ]
echo 'You must set argment.'
# >
else if [ $length -gt 1 ]
echo 'You must set only one argment.'
# >
else
# just one
git branch --set-upstream-to=origin/master $argv
return
end
end
function gbu
# check path .git
if test -e '.git'
# git status
__gbu
else
echo 'fatal: Not a git repository (or any of the parent directories): .git'
end
end

77
functions/gco.fish Normal file
View File

@ -0,0 +1,77 @@
function __git_checkout -a var
# is numeric
if [ "$var" -eq "$var" ] 2>/dev/null
# number
set length (count $arr)
if [ $var -gt $length ]
echo 'Number is large.'
return
end
set toplevel (git rev-parse --show-toplevel)
set myarg $arr[$var]
git checkout $myarg
# to allow gco from subdirs, use:
# git checkout $toplevel/$myarg
else
# not a number
git checkout $var
end
end
function __gco
# number
set res (string split "-" -- (string trim $argv))
# for branch names with hyphens, use:
# set res (string trim $argv)
set first $res[1]
set length (count $res)
set last ""
# >
if [ $length -gt 1 ]
set last $res[2]
else
# just one
#set myarg $arr[$res]
#git checkout $myarg
__git_checkout $res
return
end
# last exists
if [ $last != '' ]
# first < last
if [ $first -lt $last ]
for i in (seq $first 1 $last)
__git_checkout $i
end
else
echo 'Argument is not valid.'
end
else
__git_checkout $first
end
end
function gco
# TODO: space like, `gco 1 2 3`
set length (count $argv)
if [ $length -eq 2 ]
# more than 1
set fst (echo $argv[1] | string sub -l 1)
# if first string is -, it is option
if [ $fst = '-' ]
git checkout $argv
return
end
end
set res (string split " " -- (string trim $argv))
for i in $res
#echo $i
__gco $i
end
end

56
functions/gd.fish Normal file
View File

@ -0,0 +1,56 @@
function __gd
# number
set res (string split "-" -- (string trim $argv))
set first $res[1]
set length (count $res)
set last ""
set toplevel (git rev-parse --show-toplevel)
# >
if [ $length -gt 1 ]
set last $res[2]
else
# just one
echo $arr
set myarg $arr[$res]
echo $myarg
git diff $toplevel/$myarg
return
end
# first < last
if [ $last != '' ]
if [ $first -lt $last ]
set arr_length (count $arr)
# clamp as array length
if [ $arr_length -lt $last ]
set last $arr_length
end
#for i in (seq $first 1 $last)
for i in $res
set myarg $arr[$i]
git diff $toplevel/$myarg
end
else
echo 'Argument is not valid.'
end
else
set myarg $arr[$first]
git diff $toplevel/$myarg
end
#echo $res[1]end
end
function gd
# If we have no arguments, just run git diff
if [ (count $argv) -eq 0 ]
git diff
else
# Deal with arguments one-by-one
for i in $argv
__gd $i
end
end
end

24
functions/getopts.fish Normal file
View File

@ -0,0 +1,24 @@
function getopts --description "Parse CLI options"
set --query argv[1] || return
printf "%s\n" $argv | command awk '
{ argv[n++] = $0 }
END {
for (i = 0; i < n; i++) {
a = argv[i]
if (a == "-" || a !~ /^-/) print "_", a
else if (a == "--") while (++i < n) print "_", argv[i]
else if (a ~ /^--/)
print (m = index(a, "=")) ? substr(a, 3, m - 3) : substr(a, 3),
m ? substr(a, m + 1) : (n == i + 1 || argv[i + 1] ~ /^-/ ? "true" : argv[++i])
else {
v = substr(a, (m = match(substr(a, 3), /$|[!-@[-`{-~]|[[:space:]]/) + 2))
for (j = 2; j < m; j++)
print substr(a, j, 1),
(j + 1 < m ? "true": v == "" ? \
n == i + 1 || argv[i + 1] ~ /^-/ ? "true" : argv[++i] : v)
}
}
}
'
end

53
functions/gl.fish Normal file
View File

@ -0,0 +1,53 @@
function __git_log -a var
# is numeric
if [ "$var" -eq "$var" ] 2>/dev/null
# number
set myarg $arr[$var]
git log $myarg
else
# not a number
git log $var
end
end
function __gl
# number
set res (string split "-" -- (string trim $argv))
set first $res[1]
set length (count $res)
set last ""
# >
if [ $length -gt 1 ]
set last $res[2]
else
# just one
#set myarg $arr[$res]
#git log $myarg
__git_log $myarg
return
end
# first < last
if [ $last != '' ]
if [ $first -lt $last ]
#for i in (seq $first 1 $last)
for i in $res
#set myarg $arr[$i]
#git log $myarg
__git_log $i
end
else
echo 'argument is not valid.'
end
else
#set myarg $arr[$first]
#git log $myarg
__git_log $first
end
#echo $res[1]end
end
function gl
__gl $argv
end

58
functions/grm.fish Normal file
View File

@ -0,0 +1,58 @@
function __git_rm -a var
# is numeric
if [ "$var" -eq "$var" ] 2>/dev/null
# number
set myarg $arr[$var]
git rm $myarg
else
# not a number
git rm $var
end
end
function __grm
# number
set res (string split "-" -- (string trim $argv))
set first $res[1]
set length (count $res)
set last ""
# >
if [ $length -gt 1 ]
set last $res[2]
else
# just one
#set myarg $arr[$res]
#git rm $myarg
__git_rm $res
return
end
# first < last
if [ $last != '' ]
if [ $first -lt $last ]
#for i in (seq $first 1 $last)
for i in $res
#set myarg $arr[$i]
#git rm $myarg
__git_rm $i
end
else
echo 'argument is not valid.'
end
else
#set myarg $arr[$first]
#git rm $myarg
__git_rm $first
end
#echo $res[1]end
end
function grm
# TODO: space like, `grm 1 2 3`
set res (string split " " -- (string trim $argv))
for i in $res
#echo $i
__gco $i
end
end

200
functions/gs.fish Normal file
View File

@ -0,0 +1,200 @@
__breeze_variables
function __set_variables
set arr
set -g staged
set -g unstaged
set -g untracked
set -g ignored
set -g unmerged
set -g current_color
set -g hash "#"
set -g colon ":"
end
function __sanitize_flags -d "only allow for predefined flags"
set whitelist "--ignored" "--renames" "--no-renames"
set sanitized
for flag in (string split " " -- $argv)
if contains -- $flag $whitelist
set sanitized $sanitized $flag
end
end
echo $sanitized
end
function __parse_unmerged -a us them -d "parse shorthand status for unmerged paths"
set code "$us$them"
switch $code
case DD
set current_status "both deleted"
set current_color 'red'
case AU
set current_status "added by us"
set current_color 'yellow'
case UD
set current_status "deleted by them"
set current_color 'red'
case UA
set current_status "added by them"
set current_color 'yellow'
case DU
set current_status "deleted by us"
set current_color 'red'
case AA
set current_status "both added"
set current_color 'yellow'
case UU
set current_status "both modified"
set current_color 'green'
end
echo $current_status
end
function __parse_status -a code -d "parse shorthand status"
switch $code
case A
set current_status "new file"
set current_color 'yellow'
case C
set current_status "copied"
set current_color 'magenta'
case D
set current_status "deleted"
set current_color 'red'
case M
set current_status "modified"
set current_color 'green'
case R
set current_status "renamed"
set current_color 'blue'
case !
set current_status "ignored"
set current_color 'white'
case '?'
set current_status "untracked"
set current_color 'cyan'
end
echo $current_status
end
function __parse_state -a state -d "parse the current state"
switch $state
case staged
set current_state "Changes to be committed"
case unstaged
set current_state "Changes not staged for commit"
case untracked
set current_state "Untracked files"
case unmerged
set current_state "Unmerged paths"
case '*'
set current_state "Ignored files"
end
echo $current_state
end
function __handle_renames_and_copies -a idx name -d "removes explict rename or copy paths for unstaged files"
if test $idx = "R"
or test $idx = "C"
set elements (string split " -> " $name)
set name $elements[2]
end
echo $name
end
function __print_branch -d "print the branch information"
printf (set_color black)"$hash "(set_color normal)"On branch: "(set_color --bold white)(git branch --show-current)(set_color normal)\n(set_color black)"$hash\n"
end
function __print_state -a message length -d "print the state message"
if test $length -gt 0
set arrow "➤"
printf (set_color black)"$hash"\n(set_color normal)"$arrow $message$colon"\n(set_color black)"$hash\n"
end
end
function __format_status -a message name -d "foramt the output of the status"
echo (printf "%s %15s$colon %s %s" (set_color $current_color)$hash $message (set_color normal)"/idx/" (set_color $current_color)$name)
end
function __print_status -a st i padding -d "prints the status"
set arr $arr (echo (echo $st | string split "/idx/")[2] | string trim | string replace -r -a '\e\[[^m]*m' '' | string split " -> ")[-1]
printf (string replace "/idx/" (printf "%"$padding"s" [$i]) $st)\n
end
function __print -d "print output to screen"
set length (count $staged $unmerged $unstaged $untracked $ignored)
set idx_padding (math 2 + (count (string split '' $length )))
set states staged unmerged unstaged untracked ignored
__print_branch
set i 1
for state in $states
__print_state (__parse_state $state) (count $$state)
for st in $$state
__print_status $st $i $idx_padding
set i (math $i + 1)
end
end
if test $length -eq 0
echo (set_color black)"$hash"(set_color normal)" nothing to commit, working tree clean"
end
echo (set_color black)"$hash"
set_color normal
end
function __gs -a flags -d "group statuses by state and print to screen"
set unmerged_files (git diff --name-only --diff-filter=U)
for row in (eval (string join " " "git status --porcelain" -- $flags))
set idx (string sub -l 1 $row)
set tree (string sub -s 2 -l 1 $row)
set name (string sub -s 4 $row | string unescape )
if contains $name $unmerged_files
set unmerged $unmerged (__format_status (__parse_unmerged $idx $tree) $name)
continue
end
if test $idx = "?"
set untracked $untracked (__format_status (__parse_status $idx) $name)
continue
end
if test $idx = !
set ignored $ignored (__format_status (__parse_status $idx) $name)
continue
end
if test $idx != " "
set staged $staged (__format_status (__parse_status $idx) $name)
end
if test $tree != " "
set unstaged $unstaged (__format_status (__parse_status $tree) (__handle_renames_and_copies $idx $name))
end
end
__print
end
function gs $argv
set res (git rev-parse --is-inside-work-tree)
if [ $res = 'true' ]
__set_variables
__gs (__sanitize_flags $argv)
else
echo 'fatal: Not a git repository (or any of the parent directories): .git'
end
end

3
functions/jbo.fish Normal file
View File

@ -0,0 +1,3 @@
function jbo
echo $argv | espeak-ng -v jbo
end

37
functions/jwtd.fish Normal file
View File

@ -0,0 +1,37 @@
function jwtd
if test (count $argv) = 0
echo "Usage: jwtd TOKEN" >/dev/stderr
return 1
end
if test -z (command -v jq); or test ! -x (command -v jq)
echo "jq is not installed" >/dev/stderr
return 1
end
echo "# HEADERS"
echo "$argv[1]" | jq -R 'split(".") | .[0] | @base64d | fromjson'
echo ""
set body (echo "$argv[1]" | jq -R 'split(".") | .[1] | @base64d | fromjson')
set timestamp (echo $body | jq -r '.exp')
echo "# BODY"
echo $body | jq
echo ""
if test -n "$timestamp" -a "$timestamp" != null
if test "$timestamp" -lt (date +"%s")
echo -n "EXPIRED at: "
else
echo -n "Expires: "
end
date --date="@$timestamp"
else
echo "NEVER EXPIRES!"
end
echo "$argv[1]" | awk -F. '{print "Signature: " $3}'
end

53
functions/kex.fish Normal file
View File

@ -0,0 +1,53 @@
function kex
set -l context (kubectl config current-context)
set -l namespace apps
set -l pod ""
set -l command ""
set -l debug false
getopts $argv | while read -l key value
switch $key
case c
set context $value
case n
set namespace $value
case d
set debug $value
case _
if test -z "$pod"
set pod $value
continue
end
if test -n "$command"
set command "$command "
end
set command "$command$value"
end
end
if $debug == true
echo "Context : $context"
echo "Namespace : $namespace"
echo "Pod basename: $pod"
echo "Command : '$command'"
end
set podname (kubectl --context="$context" --namespace="$namespace" get pod -l app="$pod",instance=app -o name | shuf | head -1 | sed 's/^pod\///')
if test -z "$podname"
echo "Pod $pod not found in cluster $contexts $namespace namespace" >/dev/stderr
return 1
end
echo "Pod found : $podname"
if test -z "$command"
kubectl --context="$context" --namespace="$namespace" exec -ti "$podname" -- bash
else
kubectl --context="$context" --namespace="$namespace" exec -ti "$podname" -- bash -c "$command"
end
end

10
functions/kseal.fish Normal file
View File

@ -0,0 +1,10 @@
function kseal
echo "Enter the key to seal, end input with Ctrl-D on an empty line"
set key (cat /dev/stdin | string split0)
set context $argv[1]
set namespace $argv[2]
set name $argv[3]
echo -n $key | kubeseal --context=$context --namespace=$namespace --name=$name --raw
end

Some files were not shown because too many files have changed in this diff Show More